/*
 * Copyright (C) 2016 Socionext Inc.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include <common.h>

#include "../soc-info.h"
#include "local-init.h"
#include "stio.h"


int board_early_init_r(void)
{
	switch (uniphier_get_soc_id()) {
#if defined(CONFIG_ARCH_UNIPHIER_LD11)
	case UNIPHIER_LD11_ID:
		uniphier_ld11_local_init();	/* LD11 specific */
		uniphier_ldxx_local_init();	/* LD11/LD20 common */
		uniphier_ld11_umc_funcsel();
		uniphier_ld11_ave_drvinit();
		break;
#endif
#if defined(CONFIG_ARCH_UNIPHIER_LD20)
	case UNIPHIER_LD20_ID:
		uniphier_ld20_local_init();	/* LD20 specific */
		uniphier_ldxx_local_init();	/* LD11/LD20 common */
		uniphier_ld20_umc_funcsel();
		uniphier_ld20_ave_drvinit();
		break;
#endif
#if defined(CONFIG_ARCH_UNIPHIER_PXS3)
	case UNIPHIER_PXS3_ID:
		uniphier_pxs3_local_init();	/* PXs3 specific */
		stio_init(STIO_SETUP_USECASE_SHARED);
		uniphier_pxs3_umc_funcsel();
		uniphier_pxs3_ave_drvinit();
		break;
#endif
	default:
		break;
	}

	return 0;
}
